--- suexec.h.orig	Thu Aug 22 14:37:33 2002
+++ suexec.h	Thu Aug 22 15:21:08 2002
@@ -62,6 +62,13 @@
 #define _SUEXEC_H
 
 /*
+ * PHP_PATH -- Defines where the php binary is located
+ */
+#ifndef PHP_PATH
+#define PHP_PATH "/usr/local/bin/php"
+#endif
+
+/*
  * HTTPD_USER -- Define as the username under which Apache normally
  *               runs.  This is the only user allowed to execute
  *               this program.
--- suexec.c.orig	Thu Aug 22 14:37:28 2002
+++ suexec.c	Mon Aug 26 12:15:20 2002
@@ -263,6 +263,9 @@
     char *cmd;              /* command to be executed    */
     char cwd[AP_MAXPATH];   /* current working directory */
     char dwd[AP_MAXPATH];   /* docroot working directory */
+    char fcmd[AP_MAXPATH];  /* full path to php binary   */
+    char path[AP_MAXPATH];  /* temp                      */
+    char tpath[AP_MAXPATH]; /* temp                      */
     struct passwd *pw;      /* password entry holder     */
     struct group *gr;       /* group entry holder        */
     struct stat dir_info;   /* directory info holder     */
@@ -513,11 +516,21 @@
         }
     }
 
-    if ((strncmp(cwd, dwd, strlen(dwd))) != 0) {
-        log_err("command not in docroot (%s/%s)\n", cwd, cmd);
-        exit(114);
+    /*
+     * Full path to php binary
+     */
+    strncpy(fcmd, cwd, sizeof(fcmd));
+    strncat(fcmd, "/", sizeof(fcmd) - strlen(fcmd));
+    strncat(fcmd, cmd, sizeof(fcmd) - strlen(fcmd));
+
+    if (strncmp(fcmd, PHP_PATH, strlen(PHP_PATH)) == 0) {
+            log_err("call for php (%s)\n", fcmd);
+    }
+    else if ((strncmp(cwd, dwd, strlen(dwd))) != 0) {
+            log_err("command not in docroot (%s/%s)\n", cwd, cmd);
+            exit(114);
     }
-
+    
     /*
      * Stat the cwd and verify it is a directory, or error out.
      */
@@ -562,7 +575,17 @@
      * Error out if the target name/group is different from
      * the name/group of the cwd or the program.
      */
-    if ((uid != dir_info.st_uid) ||
+    if (strncmp(fcmd, PHP_PATH, strlen(PHP_PATH)) == 0) {
+        strncpy(tpath, getenv("PATH_TRANSLATED"), sizeof(tpath));
+        strncpy(path, tpath + strlen(getenv("DOCUMENT_ROOT")), sizeof(path));
+        log_err("corrected SCRIPT_NAME: %s -> %s\n",
+	        getenv("SCRIPT_NAME"), path);
+	setenv("SCRIPT_NAME", path, 1);
+        log_err("corrected SCRIPT_FILENAME: %s -> %s\n",
+	        getenv("SCRIPT_FILENAME"), tpath);
+	setenv("SCRIPT_FILENAME", tpath, 1);
+    }
+    else if ((uid != dir_info.st_uid) ||
         (gid != dir_info.st_gid) ||
         (uid != prg_info.st_uid) ||
         (gid != prg_info.st_gid)) {
